local hcTk = HCToolkit
local aGUI = HCToolkit.AceGUI
local colors = HCToolkit.Constants.Colors

local WrapTextInColorCode = WrapTextInColorCode

local createPanelFns = {
    ["MaidenSoakBlacklist"] = hcTk.CreateMaidenPanel,
    ["AvatarMatrixSoaks"] = hcTk.CreateAvatarPanel,
    ["KilJaedenSmallSoaks"] = hcTk.CreateKilJaedenSmallSoaksPanel,
    ["KilJaedenBigSoaks"] = hcTk.CreateKilJaedenBigSoaksPanel,
}

local treeC = nil

function hcTk.PanelInit()
    hcTk.OpenAssignments = false
end

function hcTk.AssignmentPanel()
  if (hcTk.OpenAssignments ~= true) then
    hcTk.OpenAssignments = true
    local f = aGUI:Create("Frame")
    f:SetTitle("HCToolkit Assignments")
    f:SetWidth(800)
    f:SetCallback("OnClose", function(widget) aGUI:Release(widget); hcTk.OpenAssignments = false; end)
    f:SetLayout("Fill")

    local t = aGUI:Create("TreeGroup")
    local list = hcTk.AssignmentOptions()
    t:SetTree(list)
    t:SetRelativeWidth(1)
    t:SetCallback("OnGroupSelected", hcTk.AssignmentSelectPanel)
    t:SetLayout("Flow")
    t:SelectByValue(list[1].value)
    treeC = t
    f:AddChild(treeC)
  end
end

function hcTk.AssignmentScrollContainer(container)
  local scrollContainer = aGUI:Create("SimpleGroup") -- "InlineGroup" is also good
  scrollContainer:SetFullWidth(true)
  scrollContainer:SetFullHeight(true)
  scrollContainer:SetLayout("Fill")

  container:AddChild(scrollContainer)

  scroll = aGUI:Create("ScrollFrame")
  scroll:SetLayout("Flow")
  scroll:SetFullWidth(true)
  scroll:SetFullHeight(true)
  scrollContainer:AddChild(scroll)
  return scroll;
end

function hcTk.AssignmentOptions()
    return {
        [1] = { text = "Maiden Soak Blacklist", value= "MaidenSoakBlacklist" },
        [2] = { text = "Avatar Matrix Soaks", value = "AvatarMatrixSoaks" },
        [3] = { text = "Kil'Jaeden Small Armageddons", value = "KilJaedenSmallSoaks" },
        [4] = { text = "Kil'Jaeden Big Armageddons", value = "KilJaedenBigSoaks" },
    }
end

function hcTk.AssignmentSelectPanel(container, event, group)
    container:ReleaseChildren()
    local scroll = hcTk.AssignmentScrollContainer(container)
    createPanelFns[group](scroll)
end

function hcTk.AssignmentCreateHeader(container, text)
    local h = aGUI:Create("Label")
    h:SetText(WrapTextInColorCode(" " .. text, colors["gold"]))
    h:SetFontObject(GameFontHighlightLarge)
    h:SetFullWidth(true)
    container:AddChild(hcTk.AssignmentCreateLabel(" ", 1.0))
    container:AddChild(h)
end

function hcTk.AssignmentCreateLabel(text, width)
    local l = aGUI:Create("Label")
    l:SetText(text)
    l:SetRelativeWidth(width)
    return l
end

function hcTk.AssignmentCreateEditBox(defaultText, label, textChangeFn)
    local e = aGUI:Create("EditBox")
    e:DisableButton(true)
    e:SetCallback("OnTextChanged", textChangeFn)
    e:SetLabel(label)
    e:SetText(defaultText)
    return e
end